<?php

function site_header() {
  return "<html>\n<head>\n<title>HTML to RSS & RSS feed aggregation</title>\n</head>\n<body>\n";
}

function site_menu() {
  $output = "<br />\n";
  $output .= "<a href=\"list.php\">List feeds</a>\n";
  $output .= seperator();
  $output .= "<a href=\"edit.php\">Add feed</a>\n";
  $output .= "<br />\n";
  return $output;
}


function seperator() {
  return "&nbsp;&middot;&nbsp;";
}

function ourhost() {
  $ourhost = 'http://www.newsaction.info/html2rss';
  return $ourhost;
}

function text_field($name, $size, $var, $value) {
  $output = "<tr><td>";
  $output .= $name;
  $output .= "</td><td>";
  $output .= "<input type=\"text\" size=\"$size\" name=\"edit[$var]\" value=\"$value\">";
  $output .= "</td></tr>\n";
  return $output;
}

function hidden_field($name, $var, $value) {
  $output = "<tr><td>";
  $output .= $name;
  $output .= "</td><td>$value<br />\n";
  $output .= "<input type=\"hidden\" name=\"edit[$var]\" value=\"$value\">";
  $output .= "</td></tr>\n";
  return $output;
}

/*
 * Delete a site from the database
 */
function del_site($id) {
  $result = db_query("DELETE FROM html2rss_sites WHERE id = '$id'");
  if ($result) {
    return true;
  }
  else {
    return false;
  }
}

/*
 * Load a site from the database
 */
function load_site($id) {
  $result = db_query("SELECT * FROM html2rss_sites WHERE id = '$id'");
  if (db_num_rows($result)) {
    $newslink = db_fetch_object($result);
  }
  return $newslink;
}

/*
 * Save a site to the database
 */
function save_site($vars) {
  $new = true;

  foreach ($vars as $var => $value) {
    //echo $var . " - " . $value . "<br />\n";
    if ($var == 'id') {
      $id = $value;
      $new = false;
    }
    else {
      if ($var != 'op') {
        //$fields[] = "$var = '" . mysql_escape_string($value) . "'";
        $fields[] = "$var = '" . addslashes($value) . "'";
      }
    }
  }

  if ($new) {
    $query = "INSERT INTO html2rss_sites (id) VALUES (NULL)";
    //echo $query . "<br />\n";
    $result = db_query($query);
    if ($result) {
      //echo "Result: $result<br />\n";
      $id = mysql_insert_id();
    }
    else {
      //echo "Query failed: $query<br />\n";
    }
  }

  $query = "UPDATE html2rss_sites SET " . implode($fields, ', ') .
    " WHERE id = '$id'";
  //echo $query . "<br />\n";
  $result = db_query($query);

  return $id;
}
   


/*
 * Retrieve the last twenty items for the specifed site, and make an 
 * RSS page out of it.
 */
function rss_news($id) {
  $base_url = "";
  $output = "";

  $newslink = load_site($id);

  $channel['version'] = "0.92";
  $channel['title'] = 'html2rss - ' . $newslink->src;
  $channel['link'] = $newslink->url; //"http://www.newsaction.info/html2rss/" . $id;
  $channel['description'] = 'RSS feed generated from ' . $newslink->src;
  //. var_list($newslink);
  $channel['language'] = 'en';

  if (!$newslink->limit) {
    $newslink->limit = 20;
  }
  $query = "SELECT n.link, n.text, n.teaser, n.changed, n.id, s.src FROM html2rss_news as n LEFT JOIN html2rss_sites as s USING (id) WHERE n.id = '" . $newslink->id . 
           "' ORDER BY changed DESC LIMIT " . $newslink->limit;
  $result = db_query($query);
  
  while ($item = db_fetch_object($result)) {
    if ($item->teaser) {
      $teaser  = $item->teaser;
    }
    else {
      $teaser = $item->text;
    }
    $items .= format_rss_item($item->src . " - " . $item->text, $item->link, $teaser, array('pubDate' => date('r', $item->changed)));
  }
  
  $output .= "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
  $output .= "<!DOCTYPE rss [<!ENTITY % HTMLlat1 PUBLIC \"-//W3C//ENTITIES Latin 1 for XHTML//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml-lat1.ent\">]>\n";
  $output .= "<rss version=\"". $channel["version"] . "\" xml:base=\"". $base_url ."\">\n";
  $output .= format_rss_channel($channel['title'], $channel['link'], $channel['description'], $items, $channel['language']);
  $output .= "</rss>\n";

  header('Content-Type: text/xml; charset=utf-8');
  return $output;
}

/*
 * Our version of var_dump that doesn't do it immediately.
 * This came from phpbuilder or somewhere similar, but has 
 * been tweaked a little since then.
 */
function var_list($var) {
  $string = '';

  if (is_string($var)) {
    $string = htmlspecialchars($var, ENT_QUOTES);
  } 
  elseif (is_array($var)) {
    foreach($var as $key => $value) {
      $string .= '<li>' . $key . ' : ';
      if (is_array($value) or is_object($value)) {
        $string .= '<ul>' . var_list($value) . '</ul></li>';
      } 
      else {
        $string .= $value . '</li>';
      }
    }
  } 
  elseif (is_object($var)) {
    foreach(get_object_vars($var) as $key => $value) {
      $string .= '<li>' . $key . ' : <ul>';
      $string .= var_list($value) . '</ul></li>';
    }
  } 
  else {
    $string .= "\n<BR>";
  }
  return $string;
}

/*
 * The DB is there, but there are no tables, create them
 */
function initial_setup() {
  db_query("DROP TABLE IF EXISTS html2rss_news");
  db_query("CREATE TABLE html2rss_news (
              link varchar(255) NOT NULL default '',
              text varchar(255) NOT NULL default '',
              teaser varchar(255) NOT NULL default '',
              id varchar(100) NOT NULL default '',
              changed int(11) NOT NULL default '0',
              UNIQUE KEY link (link)
            )");
  db_query("DROP TABLE IF EXISTS html2rss_sites");
  db_query("CREATE TABLE html2rss_sites (
              id int(11) not null auto_increment,
              cat varchar(50) NOT NULL default '',
              url varchar(255) not null default '',
              src varchar(255) not null default '',
              regex varchar(255) not null default '',
              href int(2) default '0',
              title int(2) default '0',
              text int(2) default '0',
              keyword varchar(50) not null default '',
              strip varchar(255) not null default '',
              base_url varchar(255) not null default '',
              link_limit int(11) default '20',
              last_checked int(11) NOT NULL default '0',
              PRIMARY KEY id (id)
            )");
              
}

function setobject(&$values) {
  $values = (object) $values;
  foreach ($values as $tkey => $val) {
    if (is_array($val)) {
      setobject($val);
      $values->$tkey = $val;
    }
  }
  return (bool) $values;
}

/*
 * function to extract news from html
 */
function find_news($newslink, $save = true) {
  global $debug;
  $output = "";
  
  logtofile("Checking: " . var_list($newslink));

  $news_query = $newslink->url;

  // Replace %Y% with the current Year, %M% with the current month
  $news_query = str_replace("%Y%", date("Y"), $news_query);
  $news_query = str_replace("%m%", date("m"), $news_query);
    
  $news = get_news($news_query);
  //logtofile($news);
    
  if ($debug > 2) {
    $output .= $news;
  }
    
  $matches = array();
  
  // Extract all links from the page, including javascript etc.
  preg_match_all("!" . $newslink->regex . "!is", $news, $matches);
  
  if ($debug > 1) {
    $output .= var_dump($matches);
  }
  
  // Moved out of loop to avoid "loop invariant" warning.
  $stripregex = "!" . $newslink->strip . "!";

  if (!$save) {
    $output = "<ul>";
  }
  
  // Loop through the list of links
  for ($i = 0 ; $i < count($matches[1]) ; $i++) {
    
    $href = $matches[$newslink->href][$i];
    $title = $matches[$newslink->title][$i];
    if ($debug > 2) {
      $output .= "href: $href\n";
      $output .= "title: $title\n";
    }
      
    if ($newslink->text) {
      if (strstr($newslink->text, "+")) {
        $fields = explode("+", $newslink->text);
        $text = '';
        foreach ($fields as $field) {
          $text .= $matches[$field][$i];
        }
      }
      else {
        $text = $matches[$newslink->text][$i];
      }
    }
    else {
      $text = '';
    }
    
    // Remove anything that the "strip" reqex asks us to
    $href = preg_replace($stripregex, "", $href);
    
    // The text should alreadu be extracted
    //$text = $matches[2][$i];
    
    // Check in case its actually an image link.
    if (stristr($title, "img")) {
      //continue;
      // Try and extract the alt text for image links
      preg_match("/alt=\"(.*?)\"/i", $title, $newtext);
      $title = $newtext[1];
    }
    
    // Ensure that the website url is present for local page references
    if (substr($href, 0, 7) != "http://") {
      $href = $newslink->base_url . $href;
    }
    
    // Finally, check it matches the keyword for the site.
    $matched = false;
    if ($newslink->keyword) {
      if (stristr($href, $newslink->keyword)) {
        $matched = true;
      }
    }
    else {
      $matched = true;
    }
    
    if ($matched) {
      $title = html_cleanup($title);
      $text = html_cleanup($text);

      if ($debug > 1) {
        $output .= "Link: $href\n";
        $output .= "Title: $title\n";
      }
      
      //$title = drupal_specialchars($title);
      //$text = drupal_specialchars($text);
      
      if ($title != "read on" && 
          $title != "more" && 
          $title != "read more" && 
          $title != "MORE..." && 
          $title != "&quot;Read More&quot;" &&
          $title != "Last Post by:" &&
          (strlen($title) > 3)
          ) {
        if ($save) {
          $query = "SELECT * FROM html2rss_news where link = '$href'";
          $found = db_query($query);
          if (db_num_rows($found) == 0) {
            // Insert it into the database
            if ($debug > 2) {
              $output .= "Inserting:\n\n";
              
              $output .= "INSERT INTO html2rss_news (link, text, teaser, id, changed) VALUES ('$href', '$title', '$text', '$newslink->id', '" . time() . "')\n";
            } else {
              $output .= "Link: $href\n";
              $output .= "Title: $title\n";
              if($text) {
                $output .= "Text: $text\n";
              }
            }
            $query = ("INSERT INTO html2rss_news (link, text, teaser, id, changed) VALUES ('$href', '$title', '$text', '$newslink->id', '" . time() . "')");
            //logtofile($query);
            db_query($query);
          } else {
            //logtofile("link $href already exists");
            if ($debug > 1) {
              $output .= "Link already exists - $href\n";
            }
          }
        }
        else {
          $output .= "<li><a href=\"$href\">$title</a><br>$text</li>\n";
        }
      }
    }
    if ($save) {
      $query = "UPDATE html2rss_sites SET last_checked = '" . time() . "' WHERE id = '" . $newslink->id . "'";
      db_query($query);
    }
  }

  if (!$save) {
    $output .= "</ul>";
  }

  return $output;
}

function thatDate($time){
  $time=time()-$time;

  $weeks =   $time/604800;
  $days =    ($time%604800)/86400;
  $hours =   (($time%604800)%86400)/3600;
  $minutes = ((($time%604800)%86400)%3600)/60;
  $seconds = (((($time%604800)%86400)%3600)%60);

  $timestring='last updated [';
  if(round($days)) $timestring.=round($days)."d ";
  if(round($hours)) $timestring.=round($hours)."h ";
  if(round($minutes)) $timestring.=round($minutes)."m";
  if(!round($minutes)&&!round($hours)&&!round($days)) $timestring.=" ".round($seconds)."s";
  $timestring.=']';

  return $timestring;
}

function calcElapsedTime($time)
{

  // calculate elapsed time (in seconds!)
  $diff = time()-$time;
  $daysDiff = 0; $hrsDiff = 0; $minsDiff = 0; $secsDiff = 0;
      
  $sec_in_a_day = 60*60*24;
  while($diff >= $sec_in_a_day){$daysDiff++; $diff -= $sec_in_a_day;}
  $sec_in_an_hour = 60*60;
  while($diff >= $sec_in_an_hour){$hrsDiff++; $diff -= $sec_in_an_hour;}
  $sec_in_a_min = 60;
  while($diff >= $sec_in_a_min){$minsDiff++; $diff -= $sec_in_a_min;}
  $secsDiff = $diff;

  return ($daysDiff.'d '.$hrsDiff.'h '.$minsDiff.'m '.$secsDiff.'s');

}

function last_item($id) {
  $query = "SELECT * FROM html2rss_news where id = '$id' ORDER BY changed DESC LIMIT 1";
  $result = db_query($query);
  if (db_num_rows($result)) {
    $newsitem = db_fetch_object($result);
    return $newsitem->changed;
  }
  else {
    return 0;
  }
}

function decode_entities($text) {
  $text= preg_replace('/&#(\d+);/me',"",$text);     //decimal notation
  $text= preg_replace('/&#x([a-f0-9]+);/mei',"",$text);  //hex notation

  $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-1"); //NOTE: UTF-8 does not work!

#  $text= preg_replace('/&#(\d+);/me',"chr(\\1)",$text);     //decimal notation
#  $text= preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)",$text);  //hex notation
  return $text;
}

function logtofile($text) {
  $logfile = "/tmp/php.log.txt";
  if (!$handle = fopen($logfile, "a+")) {
    die("failed to open logfile");
  }
  if (fwrite($handle, $text . "\n") === false) {
    die("failt to write to logfile");
  }
  fclose($handle);
}

/*
 * Remove junk from the html
 */
function html_cleanup($text) {
  //logtofile($text);

  // decode html entities
  $text = decode_entities($text);

  // remove comments
  $text = preg_replace("'<!--.*?-->'", "", $text);
  $text = preg_replace("'<!--.*?--!>'", "", $text);

  // remove bold
  $text = preg_replace("'</?b( class=\"?.*?\"?)?>'si",  "", $text);

  // remove italics
  $text = preg_replace("'</?i>'si", "", $text);

  //remove paragraph tags
  $text = preg_replace("'</?p>'si", " ", $text);

  // remove big tags
  $text = preg_replace("'</?big>'si", "", $text);

  // remove small tags
  $text = preg_replace("'</?small>'si", "", $text);

  // remove strong tags
  $text = preg_replace("'</?strong>'si", "", $text);

  // remove font tags
  $text = preg_replace("'</?font.*?>'si", "", $text);

  // remove span tags
  $text = preg_replace("'</?span.*?>'si", "", $text);

  // remove div tags
  $text = preg_replace("'</?div.*?>'si", "", $text);

  // remove em tags
  $text = preg_replace("'</?em>'si", "", $text);

  // remove h1 tags
  $text = preg_replace("'</?h[12345].*?>'si", "", $text);

  // remove br tags
  $text = preg_replace("'<br(/| /)?>'si", " ", $text);

  // Remove unprintable characters
  $text = preg_replace("'[^[a-z0-9]_ +\\?/-]'si", "", $text);
  $text = preg_replace("'[\300-\377]'si", "", $text);
  $text = preg_replace("'[\x7F-\xFF]'si", "", $text);

  // remove carriage returns
  $text = preg_replace("'\r'si", "", $text);

  // remove newlines
  $text = preg_replace("'\n'si", " ", $text);

  // remove extra blanks
  $text = preg_replace("'\s+'si", " ", $text);
  
  //logtofile($text);

  // Phew, finished
  return drupal_specialchars($text);
  //return $text;
}

/*
 * Use curl to retrieve the webpage that we are going to make and rss from
 */
function get_news($url) {
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_HEADER, 1);
  curl_setopt($ch, CURLOPT_COOKIE, 1);
  curl_setopt($ch, CURLOPT_COOKIEJAR, "/tmp/php.cookies.jar");
  curl_setopt($ch, CURLOPT_COOKIEFILE, "/tmp/php.cookies.file");
  curl_setopt($ch, CURL_USERAGENT, 'Mozilla/5.0 (compatible; Konqueror/3.1; Linux)');
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
  $data = curl_exec($ch);
  return $data;
}
?>